#include "Coordinate.h"
#include <sstream>


Coordinate::Coordinate(int x, int y) 
{
   dim = 2;
   components = new int[dim];
   components[0]=x;
   components[1]=y;
}

Coordinate::Coordinate(const Coordinate& c) {
   dim = 2;
   components = new int[dim];
	
   for (int i=0;i<dim;i++)
      components[i]=c.components[i];
}

Coordinate::~Coordinate() {
}

int Coordinate::get(int component) const
{
   if (component>=0 && component<dim) {
      return components[component];
   }
   else
      cerr << "Error in Coordinate.get, component " << component << " is out of range" << endl;

   return -1;
}

void Coordinate::set(int component,int value)
{
   if (component>=0 && component<dim) {
      components[component] = value;
   }
   else
      cerr << "Error in Coordinate.set, component " << component << " is out of range" << endl;
}


bool Coordinate::operator==(const Coordinate& c) const {
   for (int i=0;i<dim;i++)
      if (components[i] != c.components[i]) return false;
   return true;
}

string Coordinate::to_string() const {
   stringstream concatenation;
   concatenation << "(";
   for (int i=0;i<dim;i++)
   {
      concatenation << components[i];
      if (i<dim-1) // no es la última
         concatenation << ",";
   }
   concatenation << ")";
   return concatenation.str();
}

Coordinate Coordinate::operator+(const Coordinate& c) const {
   Coordinate new_c(*this);
        
   for (int i=0; i<dim; i++)
      new_c.set(i, new_c.get(i) + c.get(i));
                
   return new_c;
}

Coordinate Coordinate::operator-(const Coordinate& c) const {
   Coordinate new_c(*this); 
        
   for (int i=0; i<dim; i++)
      new_c.set(i, new_c.get(i) - c.get(i));
                
   return new_c;
}

